// where does our characterMap start in the ASCII code
#include <avr/pgmspace.h>
#include "font.h"
#include <util/delay.h>
#include <PString.h>
#include <avr/sleep.h>
#include <EEPROM.h>
#include <avr/wdt.h>
#include <avr/power.h> //Needed for powering down perihperals such as the ADC/TWI and Timers
// How many modes do we want to go through?
#define MAX_MODE 9
#define TEMPERATURE_ADJUSTMENT 26-43
#define EXTREMES_RATIO 5
#define MAXINT 32767
#define MININT -32767

int offset=TEMPERATURE_ADJUSTMENT;
#ifndef cbi
#define cbi(sfr, bit) (_SFR_BYTE(sfr) &= ~_BV(bit))
#endif
#ifndef sbi
#define sbi(sfr, bit) (_SFR_BYTE(sfr) |= _BV(bit))
#endif


byte __attribute__ ((section (".noinit"))) last_mode;

int bx=0;
int by=0;
int dx=1;
int dy=1;

//Pin Definitions

#define DISPLAY_WIDTH  4
#define DISPLAY_HEIGHT 5
int mxPin[] = {0,1,2,3,4};
//int mxPin[] = {12,11,10,9,8};
                                         
int  scdelay=0, textx=0, textindex=0;

byte videoram[11]={
B00000,
B00000,
B00000,
B00000,
B00000,
B00000,
B00000,
B00000,
B00000,
B00000,
B00000,
};

char LEDbuffer1[50];
PString led1(LEDbuffer1, sizeof(LEDbuffer1)); // LED line 1


// runs at start
void setup() {
  // set up render map


  if(bit_is_set(MCUSR, PORF)) { // Power was just established!
    MCUSR = 0; // clear MCUSR
    EEReadSettings(); // read the last mode out of eeprom
  } 
  else if(bit_is_set(MCUSR, EXTRF)) { // we're coming out of a reset condition.
    MCUSR = 0; // clear MCUSR
    last_mode++; // advance mode

    if(last_mode > MAX_MODE) {
      last_mode = 0; // reset mode
    }
  }
displayStatic(48+last_mode);
  // Try and set the random seed more randomly.  Alternate solutions involve
  // using the eeprom and writing the last seed there.
  uint16_t seed=0;
  uint8_t count=32;
  while (--count) {
    seed = (seed<<1) | (analogRead(1)&1);
  }
  randomSeed(seed);

MCUCR |= (1<<PUD); 
}

// loops continuously
void loop() {

MCUCR |= (1<<PUD);   

  // If EXTRF hasn't been asserted yet, save the mode
  EESaveSettings();

  switch(last_mode) {
    // red modes
  case 0: 
 last_mode=0; //off mode
  SleepNow();
    break;

  case 1: 
randomflashx();
    break;
  case 2: 
randomflash(6);
    break;
  case 3: 
pongflash(4);
    break;
  case 4: 
scan(5);
    break;        
  case 5: 
spiral(1);
    break;
  case 6: 
spiralx();
    break;
  case 7: 
rainflash(6);
    break;
  case 8: 
   led1.begin();
   led1.print(F(" I LOVE  YOU ! "));
   while(1)
   {
      display ();
   }
    break;
   case 9: 
   led1.begin();
   led1.print(F(" HAPPY BIRTHDAY !!! "));
   while(1)
   {
      display ();
   }
    break;

  }




}

void randomflash (byte spd)
{
while (1){
    bx=random(0, 4);
    by=random(0, 5);

blik( bx, by, spd);   
}
}

void randomflashx ()
{
while (1){
    bx=random(0, 4);
    by=random(0, 5);

blik( bx, by, random(0, 6));   
}
}

void pongflash (byte spd)
{
int bx,by,dx,dy;
while (1)
{
//    bx=0; //random(0, 4);
//    by=0; //random(0, 5);

if (bx>=3) dx=random(-1, 1);
if (by>=4) dy=random(-1, 1);
if (bx<=0) dx=random(0, 2);
if (by<=0) dy=random(0, 2);


if (bx>=3) bx=3;
if (by>=4) by=4;
if (bx<=0) bx=0;
if (by<=0) by=0;

//if (dx==0) dx=-1;
//if (dy==0) dy=-1;

//if (bx>=3) dx=-1;
//if (by>=4) dy=-1;
//if (bx==0) dx=1;
//if (by==0) dy=1;


    bx=bx+dx;
    by=by+dy;

 blik( bx, by, spd);    

}
}

void spiral (byte spd)
{
byte mx[] = {0,1,2,3, 3,3,3,3, 2,1,0, 0,0,0,  1,2, 2,2, 1, 1,1, 0,0,0,0,};
byte my[] = {0,0,0,0, 1,2,3,4, 4,4,4, 3,2,1,  1,1, 2,3, 3, 2,1, 0,0,0,0,};
while (1)
{
 for (byte n = 0; n < 21; n++)
{   
blik( mx[n], my[n], 3);      
}
 for (byte n = 0; n < 21; n++)
{   
    
blik( mx[20-n], my[20-n], 4); 
}
}
}

void spiralx ()
{
byte mx[] = {0,1,2,3, 3,3,3,3, 2,1,0, 0,0,0,  1,2, 2,2, 1, 1,1, 0,0,0,0,};
byte my[] = {0,0,0,0, 1,2,3,4, 4,4,4, 3,2,1,  1,1, 2,3, 3, 2,1, 0,0,0,0,};
while (1)
{
 
 for (byte n = 0; n < 21; n++)
{       
   setPixel( mx[20-n], my[20-n], 1);
   setup_watchdog(0); // approximately 2 seconds sleep
   system_sleep();   // 0=16ms,
  pinMode(0, INPUT); 
  pinMode(1, INPUT); 
  pinMode(2, INPUT); 
  pinMode(3, INPUT); 
  pinMode(4, INPUT); 
}
  setup_watchdog(8); // sleep
  // 0=16ms, 1=32ms,2=64ms,3=128ms,4=250ms,5=500ms 6=1 sec,7=2 sec, 8=4 sec, 9= 8sec              // wait for a second
    system_sleep();

 for (byte n = 0; n < 21; n++)
{        
      setPixel( mx[n], my[n], 1);
   setup_watchdog(0); // approximately 2 seconds sleep
   system_sleep();   // 0=16ms,
  pinMode(0, INPUT); 
  pinMode(1, INPUT); 
  pinMode(2, INPUT); 
  pinMode(3, INPUT); 
  pinMode(4, INPUT);
}
  setup_watchdog(9); // sleep
  // 0=16ms, 1=32ms,2=64ms,3=128ms,4=250ms,5=500ms 6=1 sec,7=2 sec, 8=4 sec, 9= 8sec              // wait for a second
    system_sleep();
}
}
void maze (byte spd)
{
int mx,my,bx,by,dx,dy;
    mx=random(0, 4);
    my=random(0, 5);
    bx=0; //random(0, 4);
    by=0; //random(0, 5);
 dy=1;
 dx=1;

while (1)
{


if ((bx>=3)||(bx>=mx)){
  dy=-1;
    mx=random(0, 4);
}
if ((by>=4)||(by>=my)){
  dx=-1;
  my=random(0, 5);
}

if (bx<=0) dx=random(-1, 2);
if (by<=0) dy=random(-1, 2);

if (bx>3) bx=3;
if (by>4) by=4;
if (bx<0) bx=0;
if (by<0) by=0;


    bx=bx+dx;
    by=by+dy;

 blik( bx, by, 1);    

}
}

void rainflash (byte spd)
{
int   xrain;
while (1)
{
    bx=random(0, 4);
 xrain=random(0, 7);
 for (byte by = 0; by < 5; by++)
{
blik( bx, by, xrain);  
}
}
}

void scan (byte spd)
{
int   xrain;
while (1)
{
  for (byte by = 0; by < 5; by++) 
{
 for (byte bx = 0; bx < 4; bx++)
  {
blik( bx, by, spd); 
} 
}
}
}



void blik (byte sx, byte sy, byte spd)
{
      setPixel( sx, sy, 1);
    
  setup_watchdog(0); // approximately 2 seconds sleep
   system_sleep();   // 0=16ms,
  pinMode(0, INPUT); 
  pinMode(1, INPUT); 
  pinMode(2, INPUT); 
  pinMode(3, INPUT); 
  pinMode(4, INPUT); 
  setup_watchdog(spd); // sleep
  // 0=16ms, 1=32ms,2=64ms,3=128ms,4=250ms,5=500ms 6=1 sec,7=2 sec, 8=4 sec, 9= 8sec              // wait for a second
    system_sleep();
}


EMPTY_INTERRUPT(WDT_vect);

// 0=16ms, 1=32ms,2=64ms,3=128ms,4=250ms,5=500ms
// 6=1 sec,7=2 sec, 8=4 sec, 9= 8sec
void setup_watchdog(int ii) {

  byte bb;
  int ww;
  if (ii > 9 ) ii=9;
  bb=ii & 7;
  if (ii > 7) bb|= (1<<5);
  bb|= (1<<WDCE);
  ww=bb;

  MCUSR &= ~(1<<WDRF);
  // start timed sequence
  WDTCR |= (1<<WDCE) | (1<<WDE);
  // set new watchdog timeout value
  WDTCR = bb;
  WDTCR |= _BV(WDIE);

}

void system_sleep() {
  cbi(ADCSRA,ADEN);                    // switch Analog to Digitalconverter OFF

  set_sleep_mode(SLEEP_MODE_PWR_DOWN); // sleep mode is set here
  sleep_enable();

  sleep_mode();                        // System sleeps here

  sleep_disable();                     // System continues execution here when watchdog timed out 
//  sbi(ADCSRA,ADEN);                    // switch Analog to Digitalconverter ON
}

void EEReadSettings (void) {  // TODO: Detect ANY bad values, not just 255.
  byte detectBad = 0;
  byte value = 255;
  
  value = EEPROM.read(0);
  if (value > MAX_MODE)
    detectBad = 1;
  else
    last_mode = value;  // MainBright has maximum possible value of 8.
  
  if (detectBad)
    last_mode = 0; // I prefer the rainbow effect.
}

void EESaveSettings (void){
  //EEPROM.write(Addr, Value);
  
  // Careful if you use  this function: EEPROM has a limited number of write
  // cycles in its life.  Good for human-operated buttons, bad for automation.
  
  byte value = EEPROM.read(0);

  if(value != last_mode)
    EEPROM.write(0, last_mode);
}

void SleepNow(void) {
  pinMode(0, INPUT); 
  pinMode(1, INPUT); 
  pinMode(2, INPUT); 
  pinMode(3, INPUT); 
  pinMode(4, INPUT); 
  if(last_mode > MAX_MODE) { last_mode = MAX_MODE; }

  EESaveSettings();

  // Important power management stuff follows
  ADCSRA &= ~(1<<ADEN); // turn off the ADC
  ACSR |= _BV(ACD);     // disable the analog comparator
  MCUCR |= _BV(BODS) | _BV(BODSE); // turn off the brown-out detector

  set_sleep_mode(SLEEP_MODE_PWR_DOWN); // do a complete power down
  sleep_enable(); // enable sleep mode
  sei();  // allow interrupts to end sleep mode
  sleep_cpu(); // go to sleep
  delay(500);
  sleep_disable(); // disable sleep mode for safety
}

void printChar(char number)
{
  int i;
  for( i = 0; i <3; i++){
  videoram[i+5]= (pgm_read_byte(&font_data[((number-32 )*3)+i]));
  }
  videoram[i+6]=0;
}

void scrool()
{ 
  for(int i = 1; i <11; i++){
  videoram[i-1]=videoram[i];
  }
}


//------------------------------ Multiplex ---------------------------------
void displayStatic (char number)
{
  int i;
  for( i = 0; i <3; i++){
  videoram[i+1]= (pgm_read_byte(&font_data[((number-32 )*3)+i]));
  }
  videoram[i+2]=0;

  for(int b = 0; b <10; b++){
  showRam();
  }

  
}

void display ()
{

char ch;

showRam();
showRam();
showRam();

     if (textx > 3)
     {
       ch = LEDbuffer1[textindex];
       if (ch==0) {
         textindex=0;
         ch=32; //space
       }
       printChar(ch);

     textindex++;
     textx=0;
     }
    textx++;
    scrool();

  
}


void showRam ()
{
byte colData=0;
    for(int col = 0; col <5; col++){
  colData = videoram[col];
  for(int row = 0; row <5; row++){
    if ( colData & (1<<row) ) {
setPixel( col, row, 1);
    }
    else {  
setPixel( col, row, 0);
    }
}
  }
}
void setPixel(byte x, byte y, boolean ledStatus) {
x=3-x;
  if (x >= 0 && x < DISPLAY_WIDTH) {
    if (y <= x) {
      x++;
    }
    setLed(y, x, ledStatus);
  }
}

// turn on the pins to light a LED
void setLed(byte vin, byte gnd, boolean ledStatus) {
  set_sleep_mode(SLEEP_MODE_IDLE); // do a complete power down
  sleep_enable(); // enable sleep mode
  sleep_cpu();
//  delay(1); // Wait 
  pinMode(mxPin[0], INPUT); 
  pinMode(mxPin[1], INPUT); 
  pinMode(mxPin[2], INPUT); 
  pinMode(mxPin[3], INPUT); 
  pinMode(mxPin[4], INPUT); 
//  set_sleep_mode(SLEEP_MODE_IDLE); // do a complete power down
//  sleep_enable(); // enable sleep mode
//  sleep_cpu();
  if(!ledStatus) return;

  pinMode(mxPin[vin], OUTPUT);   
  pinMode(mxPin[gnd], OUTPUT); 
  digitalWrite(mxPin[vin], HIGH);
  digitalWrite(mxPin[gnd], LOW); 

}

float readVcc() {

}

float readTemp() {
 
}


